import { AxiosResponse } from "axios";
export declare const API_URL = "https://nicehostel.herokuapp.com";
export declare const axAuth: import("axios").AxiosInstance;
export declare const axImageUpload: import("axios").AxiosInstance;
export declare const postReview: (data: PostReviewRequest) => import("axios").AxiosPromise<any>;
export declare const postRoom: (data: PublishRoomState) => import("axios").AxiosPromise<any>;
export declare const postImage: (data: any) => import("axios").AxiosPromise<any>;
export declare const postReservation: (bookInfo: BookingInfo) => import("axios").AxiosPromise<any>;
export declare const deleteImage: (delHash: string) => import("axios").AxiosPromise<any>;
export declare const authenticate: (req: LoginRequest) => Promise<AxiosResponse<UserResponse>>;
export declare const registerHost: () => Promise<AxiosResponse<UserResponse>>;
export declare const register: (req: RegisterRequest) => Promise<AxiosResponse<UserResponse>>;
export declare const fetchPropertiesView: (typeId: string | undefined, query: SearchQuery) => Promise<AxiosResponse<RoomCard[]>>;
export declare const fetchCities: () => Promise<any>;
export declare const fetchPropertyTypes: () => Promise<PropertyTypeType[]>;
export declare const fetchPropertyById: (id: string) => Promise<AxiosResponse<Room>>;
export declare const fetchPropertiesSaved: () => Promise<AxiosResponse<RoomCard[]>>;
export declare const fetchOwnerProperty: () => Promise<AxiosResponse<RoomCard[]>>;
export declare const fetchUserReservation: () => Promise<AxiosResponse<ReservationResponse[]>>;
export declare const fetchPricing: (bookInfo: BookingInfo) => Promise<AxiosResponse<CheckPricingResponse>>;
export declare const fetchReviewsForProperty: (propId?: string) => Promise<AxiosResponse<Review[]>>;
export declare const fetchServices: () => Promise<AxiosResponse<Service[]>>;
export declare const deleteReservation: (resId: string) => Promise<AxiosResponse<any>>;
export declare const useQueryParam: () => URLSearchParams;
interface ToggleLikeProps {
    roomId: string;
    token: string;
}
declare type ToggleLikeResponse = {
    liked: boolean;
};
export declare const toggleLike: ({ roomId, token }: ToggleLikeProps) => Promise<AxiosResponse<ToggleLikeResponse>>;
export declare const validateToken: (token: string) => Promise<Response>;
export {};
//# sourceMappingURL=API.d.ts.map