import {Box,VStack,Avatar,Button,Icon,Divider,Spacer,useDisclosure,useToast,Flex,useColorModeValue,Stack,UnorderedList,Grid,ListItem,SimpleGrid,Modal,ModalOverlay,ModalContent,ModalHeader,ModalBody,IconButton,Textarea}from'@chakra-ui/react';import React__default from'react';import {BsStarFill,BsStar}from'react-icons/bs';import {FaUserShield,FaCheck}from'react-icons/fa';import {useQuery,useMutation}from'react-query';import {useQueryParam,fetchUserReservation,deleteReservation,fetchPropertiesSaved,postReview}from'../API.js';import RoomCard from'../components/FilterComponents/RoomCard.js';import {AuthContext}from'../Contexts/AuthContext.js';const ProfilePage = () => {
    var _a;
    const { user } = React__default.useContext(AuthContext);
    let query = useQueryParam();
    let view = (_a = query.get("view")) === null || _a === void 0 ? void 0 : _a.toLowerCase();
    return (React__default.createElement(Box, { d: "flex", flexDir: { base: "column", md: "row" } },
        React__default.createElement(Box, { w: { base: "100%", md: "25%" }, minW: "300px" },
            React__default.createElement(Box, { d: "flex", overflow: "hidden", borderWidth: "1px", borderRadius: "lg", p: "4", flexDir: { base: "row-reverse", md: "column" }, spacing: "2" },
                React__default.createElement(VStack, { alignSelf: "center", justifySelf: "start" },
                    React__default.createElement(Avatar, { name: user === null || user === void 0 ? void 0 : user.name, boxSize: { base: "20", md: "40" } }),
                    React__default.createElement(Button, { variant: "link", my: "2", fontSize: "sm" }, "Update photo")),
                React__default.createElement(VStack, { alignItems: "start", spacing: "2" },
                    React__default.createElement(Icon, { as: FaUserShield, boxSize: "8" }),
                    React__default.createElement(Box, { as: "h4", fontWeight: "bold", fontSize: "lg", fontFamily: "mono" }, "Identity verification"),
                    React__default.createElement(Box, { as: "h4" }, "Show others you\u2019re really you with the identity verification badge."),
                    React__default.createElement(Divider, null),
                    React__default.createElement(Box, { as: "h4", fontWeight: "bold", fontSize: "lg", fontFamily: "mono" }, (user === null || user === void 0 ? void 0 : user.name) + " confirmed"),
                    React__default.createElement(Box, { d: "flex", flexDir: "row", alignItems: "baseline" },
                        React__default.createElement(FaCheck, null),
                        React__default.createElement(Box, { as: "h4", ml: "4" }, "Email confirmed")),
                    React__default.createElement(Box, { d: "flex", flexDir: "row", alignItems: "baseline" },
                        React__default.createElement(FaCheck, null),
                        React__default.createElement(Box, { as: "h4", ml: "4" }, "Phone confirmed"))))),
        React__default.createElement(Spacer, { minW: "2" }),
        React__default.createElement(Box, { w: { base: "100%", md: "65%" } },
            (view === "likes" || view == null) && React__default.createElement(UserLikesProperties, null),
            view === "notifications" && React__default.createElement(Notifications, null),
            view === "reservations" && React__default.createElement(Reservations, null))));
};
const ReviewModal = (modalProps) => {
    const [starHover, setStarHover] = React__default.useState(0);
    const [starReview, setStarReview] = React__default.useState(0);
    const [comment, setComment] = React__default.useState();
    const starColor = useColorModeValue("red", "yellow");
    const toast = useToast();
    const { onClose } = modalProps;
    const mutateReview = useMutation(postReview, {
        onSuccess: (res) => {
            console.log(res.data);
            toast({
                description: "Successfully sent review",
                status: "success"
            });
        },
        onError: (e) => {
            console.log(e);
        }
    });
    const sendReview = () => {
        mutateReview.mutate({
            propertyId: modalProps.propId,
            starCount: starReview,
            reviewComment: comment,
            reservationId: modalProps.reservationId
        });
    };
    return (React__default.createElement(Modal, Object.assign({}, modalProps, { onClose: () => { setStarReview(0); onClose(); } }),
        React__default.createElement(ModalOverlay, null),
        React__default.createElement(ModalContent, null,
            React__default.createElement(ModalHeader, null, "Write a review"),
            React__default.createElement(ModalBody, null,
                React__default.createElement(Flex, { flexDir: "column", gridGap: "2" },
                    React__default.createElement(Box, null, Array(5).fill(5).map((_, index) => {
                        return (React__default.createElement(IconButton, { variant: "ghost", "aria-label": "star", key: index, onClick: () => { setStarReview(index + 1); }, _focus: { borderWidth: "1px" }, borderRadius: "full", onMouseOver: () => setStarHover(index + 1), onMouseLeave: () => setStarHover(0), icon: starHover > index || starReview > index ? React__default.createElement(BsStarFill, { color: starColor }) : React__default.createElement(BsStar, null) }));
                    })),
                    React__default.createElement(Textarea, { size: "md", placeholder: "Please describe some of your thoughts", value: comment, onChange: (e) => setComment(e.target.value) }),
                    React__default.createElement(Button, { ml: "auto", isDisabled: starReview <= 0, onClick: sendReview }, "Send"))))));
};
const Reservations = (boxprops) => {
    var _a;
    const reviewModal = useDisclosure();
    const auth = React__default.useContext(AuthContext);
    const toast = useToast();
    const [propIdReview, setPropIdReview] = React__default.useState("");
    const { data, error, isError } = useQuery(["reservations", (_a = auth.user) === null || _a === void 0 ? void 0 : _a.token], fetchUserReservation, {
        onSuccess: (res) => {
        },
        retry: 2,
    });
    const deleteRsvMutate = useMutation(deleteReservation, {
        onSuccess: () => { toast({ description: "Reservation is canceled", status: "success" }); },
        onError: (error) => {
            toast({ description: error.errors, status: "success" });
        }
    });
    const handleDelete = (resId) => {
        deleteRsvMutate.mutate(resId);
    };
    if ((data === null || data === void 0 ? void 0 : data.data.length) === 0) {
        return React__default.createElement(Box, null, "You don't have any reservations");
    }
    if (isError)
        return React__default.createElement(Box, null, "Something's wrong");
    return React__default.createElement(Box, Object.assign({}, boxprops),
        React__default.createElement(Flex, { gridGap: "2", flexDir: "column" },
            React__default.createElement(Box, { as: "h1", fontFamily: "heading", fontWeight: "bold", fontSize: "4xl", mb: "3" }, "Your reservations"), data === null || data === void 0 ? void 0 :
            data.data.map(d => React__default.createElement(Box, { borderWidth: "1px", p: "2", style: { transition: "ease 0.3s" }, _hover: { transform: "scale(1.02)" }, 
                // eslint-disable-next-line react-hooks/rules-of-hooks
                bg: useColorModeValue('gray.100', 'gray.800'), borderRadius: "10px" },
                React__default.createElement(Flex, { key: d.id, w: "100%", flexDir: "row", gridGap: "2" },
                    React__default.createElement(Stack, { w: "100%", gridGap: "2" },
                        React__default.createElement(UnorderedList, { h: "100%" },
                            React__default.createElement(Grid, { h: "100%", fontWeight: "bold", gridTemplateColumns: { base: "1fr", md: "1fr 1fr" }, templateRows: "auto", gridGap: "2" },
                                React__default.createElement(ListItem, null,
                                    React__default.createElement(Box, { as: "h3" }, "From Date: ")),
                                React__default.createElement(Box, { fontWeight: "light" }, d.fromDate),
                                React__default.createElement(ListItem, null,
                                    React__default.createElement(Box, { as: "h3" }, "To Date: ")),
                                React__default.createElement(Box, { fontWeight: "light" }, d.toDate),
                                React__default.createElement(ListItem, null,
                                    React__default.createElement(Box, { as: "h3" }, "Total Cost: ")),
                                React__default.createElement(Box, { fontWeight: "light" }, d.total),
                                React__default.createElement(ListItem, null,
                                    React__default.createElement(Box, { as: "h3" }, "Reserved from: ")),
                                React__default.createElement(Box, { fontWeight: "light" }, d.createdAt),
                                React__default.createElement(ListItem, null,
                                    React__default.createElement(Box, { as: "h3" }, "Reservations Status: ")),
                                React__default.createElement(Box, { fontWeight: "light" }, d.reservationStatus),
                                React__default.createElement(ListItem, null,
                                    React__default.createElement(Box, { as: "h3" }, "Payment Status: ")),
                                React__default.createElement(Box, { fontWeight: "light" }, d.paymentStatus),
                                React__default.createElement(Button, { colorScheme: "green", onClick: () => { setPropIdReview(d.property.id); reviewModal.onOpen(); } }, "Write a review"),
                                React__default.createElement(Button, { colorScheme: "red", isDisabled: d.reservationStatus.toLowerCase() !== "on reserved", onClick: () => { handleDelete(d.id); } }, "Cancel reservation")))),
                    React__default.createElement(Box, { ml: "auto" },
                        React__default.createElement(Divider, { orientation: "vertical", borderColor: "currentcolor" })),
                    React__default.createElement(RoomCard, { room: d.property, isSaved: true, flex: '0 0 15em', borderWidth: "0px" })))),
            React__default.createElement(ReviewModal, { isOpen: reviewModal.isOpen, isCentered: true, onClose: reviewModal.onClose, reservationId: "", propId: propIdReview })));
};
const UserLikesProperties = () => {
    const { data } = useQuery("propertiesLiked", () => fetchPropertiesSaved(), {
        onSuccess: (res) => {
        },
        refetchOnMount: "always",
    });
    if ((data === null || data === void 0 ? void 0 : data.data.length) === 0)
        return React__default.createElement(Box, null, "Looks like you didn't save any room");
    return (React__default.createElement(Box, null,
        React__default.createElement(Box, { as: "h1", fontFamily: "heading", fontWeight: "bold", fontSize: "4xl", mb: "3" }, "Rooms that you saved"),
        React__default.createElement(SimpleGrid, { spacing: "4", columns: { base: 1, lg: 2 } }, data === null || data === void 0 ? void 0 : data.data.map(r => React__default.createElement(RoomCard, { room: r, key: r.id, isSaved: true })))));
};
const Notifications = () => {
    return (React__default.createElement(Box, null, "Notification"));
};export default ProfilePage;//# sourceMappingURL=ProfilePage.js.map
