import {useToast,useDisclosure,Box,Button,Collapse,Alert,AlertIcon,AlertTitle,AlertDescription}from'@chakra-ui/react';import React__default,{useContext}from'react';import {registerHost}from'../API.js';import {AuthContext}from'../Contexts/AuthContext.js';const RegisterHostPage = () => {
    var _a, _b;
    const auth = useContext(AuthContext);
    const toast = useToast();
    const alert = useDisclosure();
    const handleRegisterClick = () => {
        alert.onOpen();
        registerHost().then(res => {
            console.log(res);
            if (res.status === 200) {
                localStorage.setItem("token", res.data.token);
                auth.updateToken(res.data.token);
                toast({
                    description: "Congrat! You are eligible as a new host!",
                    status: "success"
                });
            }
        }).catch(err => {
            toast({
                description: err,
                status: "error"
            });
        });
    };
    return (React__default.createElement(Box, { d: "flex", flexDir: "column", gridGap: "2", justifyItems: "center", justifyContent: "center" },
        React__default.createElement(Button, { onClick: () => handleRegisterClick(), colorScheme: "green", w: "30ch", isDisabled: (_a = auth.user) === null || _a === void 0 ? void 0 : _a.roles.includes("Owner"), alignSelf: "center" }, ((_b = auth.user) === null || _b === void 0 ? void 0 : _b.roles.includes("Owner")) ? "You are already a host!" : "Register to become a host!"),
        React__default.createElement(Collapse, { in: alert.isOpen },
            React__default.createElement(SuccessAlert, null))));
};
const SuccessAlert = () => React__default.createElement(Alert, { status: "success", variant: "subtle", flexDirection: "column", alignItems: "center", justifyContent: "center", textAlign: "center", height: "200px" },
    React__default.createElement(AlertIcon, { boxSize: "40px", mr: 0 }),
    React__default.createElement(AlertTitle, { mt: 4, mb: 1, fontSize: "lg" }, "Application submitted!"),
    React__default.createElement(AlertDescription, { maxWidth: "sm" }, "Thanks for submitting your application. Our team will get back to you soon."));export default RegisterHostPage;//# sourceMappingURL=RegisterHostPage.js.map
