import {__rest}from'tslib';import {useColorModeValue,Box,HStack,Spinner,Tag,TagLabel,TagCloseButton}from'@chakra-ui/react';import React__default from'react';import {useQuery}from'react-query';import {useLocation}from'react-router-dom';import {fetchPropertiesView}from'../API.js';import RoomCardList from'../components/FilterComponents/RoomCardList.js';import SearchBar from'../components/NavComponents/SearchBar.js';const RoomsPage = () => {
    new URLSearchParams(useLocation().search);
    const searchBoxColor = useColorModeValue("gray.100", "gray.900");
    const location = useLocation();
    const [search, setSearch] = React__default.useState({ childrenNum: 0, guestNum: 0 });
    const [type, setType] = React__default.useState();
    const updateSearch = (search) => {
        setSearch(search);
    };
    React__default.useEffect(() => {
        if (location.state !== undefined && location.state.search) {
            setSearch(location.state.search);
        }
        if (location.state !== undefined && location.state.type) {
            setType(location.state.type);
        }
    }, []);
    let queryKeys = [type === null || type === void 0 ? void 0 : type.id, search];
    const { data, isLoading, error, refetch, remove } = useQuery(["propertyView", queryKeys], () => fetchPropertiesView(type === null || type === void 0 ? void 0 : type.id, search), {
        staleTime: 1000 * 60
    });
    if (error) {
        return React__default.createElement(React__default.Fragment, null, "Error");
    }
    return (React__default.createElement(Box, { d: "flex", flexDir: "column", gridGap: "5" },
        React__default.createElement(Box, { position: { lg: "sticky" }, top: 0, bgColor: searchBoxColor, d: "flex", flexDir: "column", boxShadow: "2xl", gridGap: "5", pb: "5" },
            React__default.createElement(SearchBar, { search: search, updateSearch: updateSearch, isLoading: isLoading, onClickSearch: () => { remove(); refetch(); } }),
            React__default.createElement(HStack, null,
                type && React__default.createElement(QueryTag, { label: "Property type: " + type.propertyType, onClose: () => { setType(undefined); } }),
                search.city && React__default.createElement(QueryTag, { label: search.city, onClose: () => { setSearch(s => (Object.assign(Object.assign({}, s), { city: "" }))); } }),
                search.from && React__default.createElement(QueryTag, { label: "From: " + search.from.toLocaleDateString(), onClose: () => { setSearch(s => (Object.assign(Object.assign({}, s), { from: undefined }))); } }),
                search.to && React__default.createElement(QueryTag, { label: "To: " + search.to.toLocaleDateString(), onClose: () => { setSearch(s => (Object.assign(Object.assign({}, s), { to: undefined }))); } }),
                search.guestNum > 0 && React__default.createElement(QueryTag, { label: search.guestNum + " guests", onClose: () => { setSearch(s => (Object.assign(Object.assign({}, s), { guestNum: 0 }))); } }),
                search.childrenNum > 0 && React__default.createElement(QueryTag, { label: search.childrenNum + " children", onClose: () => { setSearch(s => (Object.assign(Object.assign({}, s), { childrenNum: 0 }))); } }))),
        React__default.createElement(Box, { as: "h3", mb: "5", fontSize: "4xl", fontWeight: "bold" }, "Find place that fits you most..."),
        isLoading ?
            React__default.createElement(Spinner, { color: "green", size: "lg", alignSelf: "center" })
            :
                React__default.createElement(RoomCardList, { rooms: data === null || data === void 0 ? void 0 : data.data })));
};
const QueryTag = (props) => {
    const tagProps = __rest(props, ["label", "onClose"]);
    return (React__default.createElement(Tag, Object.assign({ size: "lg", colorScheme: "green" }, tagProps),
        React__default.createElement(TagLabel, null, props.label),
        React__default.createElement(TagCloseButton, { onClick: () => props.onClose() })));
};export default RoomsPage;//# sourceMappingURL=RoomsPage.js.map
