import {Box,VStack,Link,Tooltip,Image}from'@chakra-ui/react';import React__default from'react';import {useHistory}from'react-router-dom';import Slider from'react-slick';import {useQuery}from'react-query';import {fetchPropertyTypes}from'../../API.js';var settings = {
    dots: true,
    infinite: true,
    speed: 500,
    slidesToShow: 4,
    slidesToScroll: 1,
    initialSlide: 0,
    swipeToSlide: true,
    responsive: [
        {
            breakpoint: 1024,
            settings: {
                slidesToShow: 4,
                slidesToScroll: 1,
                infinite: true,
                dots: true,
            },
        },
        {
            breakpoint: 600,
            settings: {
                slidesToShow: 3,
                slidesToScroll: 1,
                initialSlide: 2,
            },
        },
        {
            breakpoint: 480,
            settings: {
                slidesToShow: 1,
                slidesToScroll: 1,
            },
        },
    ],
};
const PropertyTypeList = () => {
    const { data, isError, isFetching } = useQuery('propertypeList', fetchPropertyTypes, {
        staleTime: 1000 * 60 * 10,
    });
    if (isFetching)
        console.log('refetching prop');
    if (isError)
        return React__default.createElement(Box, null, "Something's wrong");
    return (React__default.createElement("div", null,
        React__default.createElement(Slider, Object.assign({}, settings), data === null || data === void 0 ? void 0 : data.map((d, key) => (React__default.createElement(PropertyType, { type: d, key: key }))))));
};
const PropertyType = ({ type, children }) => {
    const history = useHistory();
    const handlePropTypeClick = () => {
        history.push({
            pathname: '/rooms',
            state: {
                type: type,
            },
        });
    };
    return (React__default.createElement(VStack, { alignItems: "start", p: "4" },
        React__default.createElement(Link, { onClick: handlePropTypeClick },
            React__default.createElement(Tooltip, { hasArrow: true, placement: "top", "aria-label": 'tooltips', label: type.description, openDelay: 500 },
                React__default.createElement(Box, null,
                    React__default.createElement(Box, { maxW: "sm", maxH: "sm", minH: "100px" },
                        React__default.createElement(Image, { width: "inherit", height: "inherit", src: type.thumbnailImg, objectFit: "cover" })),
                    React__default.createElement(Box, { mt: "1", fontWeight: "semibold", as: "h4", lineHeight: "tight", isTruncated: true }, type.propertyType)))),
        React__default.createElement(Box, { color: "gray.500", fontSize: "md" }, type.count + ' ' + type.propertyType + '')));
};export default PropertyTypeList;//# sourceMappingURL=PropertyTypeList.js.map
